﻿using System;
using System.Runtime.InteropServices;

namespace TestProject
{
    public static class TaskbarHelper
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Structure
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 윈도우 깜박이기 정보 - FLASHWINFO

        /// <summary>
        /// 윈도우 깜박이기 정보
        /// </summary>
        [StructLayout(LayoutKind.Sequential)]
        public struct FLASHWINFO
        {
            //////////////////////////////////////////////////////////////////////////////////////////////////// Field
            ////////////////////////////////////////////////////////////////////////////////////////// Public

            #region Field

            /// <summary>
            /// 크기
            /// </summary>
            public uint Size;

            /// <summary>
            /// 윈도우 핸들
            /// </summary>
            public IntPtr WindowHandle;

            /// <summary>
            /// 플래그
            /// </summary>
            public uint Flag;

            /// <summary>
            /// 카운트
            /// </summary>
            public uint Count;

            /// <summary>
            /// 타임아웃
            /// </summary>
            public uint Timeout;

            #endregion
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Import
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Private

        #region 윈도우 작업 표시줄 깜박이기 - FlashWindowEx(info);

        /// <summary>
        /// 윈도우 작업 표시줄 깜박이기
        /// </summary>
        /// <param name="info">윈도우 작업 표시줄 깜박이기 정보</param>
        /// <returns>처리 결과</returns>
        [DllImport("user32")]
        private static extern int FlashWindowEx(ref FLASHWINFO info);

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field 

        /// <summary>
        /// FLASHW_STOP
        /// </summary>
        private const uint FLASHW_STOP = 0;

        /// <summary>
        /// FLASHW_CAPTION
        /// </summary>
        private const uint FLASHW_CAPTION = 1;

        /// <summary>
        /// FLASHW_TRAY
        /// </summary>
        private const uint FLASHW_TRAY = 2;

        /// <summary>
        /// FLASHW_ALL
        /// </summary>
        private const uint FLASHW_ALL = 3;

        /// <summary>
        /// FLASHW_TIMER
        /// </summary>
        private const uint FLASHW_TIMER = 4;

        /// <summary>
        /// FLASHW_TIMERNOFG
        /// </summary>
        private const uint FLASHW_TIMERNOFG = 12;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region 윈도우 깜박이기 - FlashWindow(windowHandle)

        /// <summary>
        /// 윈도우 깜박이기
        /// </summary>
        /// <param name="windowHandle">윈도우 핸들</param>
        /// <returns>처리 결과</returns>
        public static bool FlashWindow(IntPtr windowHandle)
        {
            FLASHWINFO info = new FLASHWINFO();

            info.Size         = Convert.ToUInt32(Marshal.SizeOf(info));
            info.WindowHandle = windowHandle;
            info.Flag         = FLASHW_ALL | FLASHW_TIMERNOFG;
            info.Count        = uint.MaxValue;
            info.Timeout      = 0;

            return (FlashWindowEx(ref info) == 0);
        }

        #endregion
    }
}